create table DNA_NAMESPACES (id bigint generated by default as identity, URI varchar(512), primary key (id));
create table DNA_WORKSPACES (id bigint generated by default as identity, NAME varchar(128) not null, primary key (id));
create table MODE_OPTIONS (NAME varchar(128) not null, VALUE varchar(512) not null, primary key (NAME));
create table MODE_SIMPLE_LARGE_VALUES (SHA1 varchar(40) not null, COMPRESSED smallint, DATA blob(255) not null, LENGTH bigint not null, TYPE varchar(255) not null, primary key (SHA1));
create table MODE_SIMPLE_NODE (ID bigint generated by default as identity, ALLOWS_SNS smallint not null, CHILD_NAME_LOCAL varchar(512), COMPRESSED smallint, DATA blob(255), CHILD_INDEX integer not null, NODE_UUID varchar(36) not null, NUM_PROPS integer not null, ENFORCEREFINTEG smallint not null, SNS_INDEX integer not null, WORKSPACE_ID bigint not null, CHILD_NAME_NS_ID bigint, PARENT_ID bigint, primary key (ID));
create table MODE_SUBGRAPH_NODES (ID bigint generated by default as identity, DEPTH integer not null, CHILD_NUM integer not null, UUID varchar(36) not null, PARENT_NUM integer not null, QUERY_ID bigint not null, primary key (ID));
create table MODE_SUBGRAPH_QUERIES (ID bigint generated by default as identity, ROOT_UUID varchar(36) not null, WORKSPACE_ID bigint not null, primary key (ID));
create table ModeShape_LARGEVALUE_USAGES (ID bigint not null, largeValues_SHA1 varchar(40) not null, primary key (ID, largeValues_SHA1));
create index NS_URI_INX on DNA_NAMESPACES (URI);
create index WS_NAME_INX on DNA_WORKSPACES (NAME);
create index CHILDINDEX_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, PARENT_ID, CHILD_INDEX);
create index CHILDNAME_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, PARENT_ID, CHILD_NAME_NS_ID, CHILD_NAME_LOCAL, SNS_INDEX);
create index NODEUUID_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, NODE_UUID);
alter table MODE_SIMPLE_NODE add constraint FKE43E2BD346EF783F foreign key (CHILD_NAME_NS_ID) references DNA_NAMESPACES;
alter table MODE_SIMPLE_NODE add constraint FKE43E2BD360F39011 foreign key (PARENT_ID) references MODE_SIMPLE_NODE;
create index QUERYID_INX on MODE_SUBGRAPH_NODES (QUERY_ID, UUID, DEPTH);
alter table ModeShape_LARGEVALUE_USAGES add constraint FK4B54E5DAE58CEC5C foreign key (ID) references MODE_SIMPLE_NODE;
alter table ModeShape_LARGEVALUE_USAGES add constraint FK4B54E5DA1B6FBC1C foreign key (largeValues_SHA1) references MODE_SIMPLE_LARGE_VALUES;
