create table DNA_NAMESPACES (id numeric(19,0) identity not null, URI varchar(512) null, primary key (id));
create table DNA_WORKSPACES (id numeric(19,0) identity not null, NAME varchar(128) not null, primary key (id));
create table MODE_OPTIONS (NAME varchar(128) not null, VALUE varchar(512) not null, primary key (NAME));
create table MODE_SIMPLE_LARGE_VALUES (SHA1 varchar(40) not null, COMPRESSED tinyint null, DATA image not null, LENGTH numeric(19,0) not null, TYPE varchar(255) not null, primary key (SHA1));
create table MODE_SIMPLE_NODE (ID numeric(19,0) identity not null, ALLOWS_SNS tinyint not null, CHILD_NAME_LOCAL varchar(512) null, COMPRESSED tinyint null, DATA image null, CHILD_INDEX int not null, NODE_UUID varchar(36) not null, NUM_PROPS int not null, ENFORCEREFINTEG tinyint not null, SNS_INDEX int not null, WORKSPACE_ID numeric(19,0) not null, CHILD_NAME_NS_ID numeric(19,0) null, PARENT_ID numeric(19,0) null, primary key (ID));
create table MODE_SUBGRAPH_NODES (ID numeric(19,0) identity not null, DEPTH int not null, CHILD_NUM int not null, UUID varchar(36) not null, PARENT_NUM int not null, QUERY_ID numeric(19,0) not null, primary key (ID));
create table MODE_SUBGRAPH_QUERIES (ID numeric(19,0) identity not null, ROOT_UUID varchar(36) not null, WORKSPACE_ID numeric(19,0) not null, primary key (ID));
create table ModeShape_LARGEVALUE_USAGES (ID numeric(19,0) not null, largeValues_SHA1 varchar(40) not null, primary key (ID, largeValues_SHA1));
create index NS_URI_INX on DNA_NAMESPACES (URI);
create index WS_NAME_INX on DNA_WORKSPACES (NAME);
create index CHILDINDEX_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, PARENT_ID, CHILD_INDEX);
create index CHILDNAME_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, PARENT_ID, CHILD_NAME_NS_ID, CHILD_NAME_LOCAL, SNS_INDEX);
create index NODEUUID_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, NODE_UUID);
alter table MODE_SIMPLE_NODE add constraint FKE43E2BD346EF783F foreign key (CHILD_NAME_NS_ID) references DNA_NAMESPACES;
alter table MODE_SIMPLE_NODE add constraint FKE43E2BD360F39011 foreign key (PARENT_ID) references MODE_SIMPLE_NODE;
create index QUERYID_INX on MODE_SUBGRAPH_NODES (QUERY_ID, UUID, DEPTH);
alter table ModeShape_LARGEVALUE_USAGES add constraint FK4B54E5DAE58CEC5C foreign key (ID) references MODE_SIMPLE_NODE;
alter table ModeShape_LARGEVALUE_USAGES add constraint FK4B54E5DA1B6FBC1C foreign key (largeValues_SHA1) references MODE_SIMPLE_LARGE_VALUES;
