create table DNA_NAMESPACES (id bigint not null auto_increment, URI varchar(512), primary key (id)) ENGINE=InnoDB;
create table DNA_WORKSPACES (id bigint not null auto_increment, NAME varchar(128) not null, primary key (id)) ENGINE=InnoDB;
create table MODE_OPTIONS (NAME varchar(128) not null, VALUE varchar(512) not null, primary key (NAME)) ENGINE=InnoDB;
create table MODE_SIMPLE_LARGE_VALUES (SHA1 varchar(40) not null, COMPRESSED bit, DATA blob not null, LENGTH bigint not null, TYPE varchar(255) not null, primary key (SHA1)) ENGINE=InnoDB;
create table MODE_SIMPLE_NODE (ID bigint not null auto_increment, ALLOWS_SNS bit not null, CHILD_NAME_LOCAL varchar(512), COMPRESSED bit, DATA blob, CHILD_INDEX integer not null, NODE_UUID varchar(36) not null, NUM_PROPS integer not null, ENFORCEREFINTEG bit not null, SNS_INDEX integer not null, WORKSPACE_ID bigint not null, CHILD_NAME_NS_ID bigint, PARENT_ID bigint, primary key (ID)) ENGINE=InnoDB;
create table MODE_SUBGRAPH_NODES (ID bigint not null auto_increment, DEPTH integer not null, CHILD_NUM integer not null, UUID varchar(36) not null, PARENT_NUM integer not null, QUERY_ID bigint not null, primary key (ID)) ENGINE=InnoDB;
create table MODE_SUBGRAPH_QUERIES (ID bigint not null auto_increment, ROOT_UUID varchar(36) not null, WORKSPACE_ID bigint not null, primary key (ID)) ENGINE=InnoDB;
create table ModeShape_LARGEVALUE_USAGES (ID bigint not null, largeValues_SHA1 varchar(40) not null, primary key (ID, largeValues_SHA1)) ENGINE=InnoDB;
create index NS_URI_INX on DNA_NAMESPACES (URI);
create index WS_NAME_INX on DNA_WORKSPACES (NAME);
create index CHILDINDEX_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, PARENT_ID, CHILD_INDEX);
create index CHILDNAME_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, PARENT_ID, CHILD_NAME_NS_ID, CHILD_NAME_LOCAL, SNS_INDEX);
create index NODEUUID_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, NODE_UUID);
alter table MODE_SIMPLE_NODE add index FKE43E2BD346EF783F (CHILD_NAME_NS_ID), add constraint FKE43E2BD346EF783F foreign key (CHILD_NAME_NS_ID) references DNA_NAMESPACES (id);
alter table MODE_SIMPLE_NODE add index FKE43E2BD360F39011 (PARENT_ID), add constraint FKE43E2BD360F39011 foreign key (PARENT_ID) references MODE_SIMPLE_NODE (ID);
create index QUERYID_INX on MODE_SUBGRAPH_NODES (QUERY_ID, UUID, DEPTH);
alter table ModeShape_LARGEVALUE_USAGES add index FK4B54E5DAE58CEC5C (ID), add constraint FK4B54E5DAE58CEC5C foreign key (ID) references MODE_SIMPLE_NODE (ID);
alter table ModeShape_LARGEVALUE_USAGES add index FK4B54E5DA1B6FBC1C (largeValues_SHA1), add constraint FK4B54E5DA1B6FBC1C foreign key (largeValues_SHA1) references MODE_SIMPLE_LARGE_VALUES (SHA1);
