create table DNA_NAMESPACES (id int8 not null, URI varchar(512), primary key (id));
create table DNA_WORKSPACES (id int8 not null, NAME varchar(128) not null, primary key (id));
create table MODE_OPTIONS (NAME varchar(128) not null, VALUE varchar(512) not null, primary key (NAME));
create table MODE_SIMPLE_LARGE_VALUES (SHA1 varchar(40) not null, COMPRESSED bool, DATA oid not null, LENGTH int8 not null, TYPE varchar(255) not null, primary key (SHA1));
create table MODE_SIMPLE_NODE (ID int8 not null, ALLOWS_SNS bool not null, CHILD_NAME_LOCAL varchar(512), COMPRESSED bool, DATA oid, CHILD_INDEX int4 not null, NODE_UUID varchar(36) not null, NUM_PROPS int4 not null, ENFORCEREFINTEG bool not null, SNS_INDEX int4 not null, WORKSPACE_ID int8 not null, CHILD_NAME_NS_ID int8, PARENT_ID int8, primary key (ID));
create table MODE_SUBGRAPH_NODES (ID int8 not null, DEPTH int4 not null, CHILD_NUM int4 not null, UUID varchar(36) not null, PARENT_NUM int4 not null, QUERY_ID int8 not null, primary key (ID));
create table MODE_SUBGRAPH_QUERIES (ID int8 not null, ROOT_UUID varchar(36) not null, WORKSPACE_ID int8 not null, primary key (ID));
create table ModeShape_LARGEVALUE_USAGES (ID int8 not null, largeValues_SHA1 varchar(40) not null, primary key (ID, largeValues_SHA1));
create index NS_URI_INX on DNA_NAMESPACES (URI);
create index WS_NAME_INX on DNA_WORKSPACES (NAME);
create index CHILDINDEX_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, PARENT_ID, CHILD_INDEX);
create index CHILDNAME_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, PARENT_ID, CHILD_NAME_NS_ID, CHILD_NAME_LOCAL, SNS_INDEX);
create index NODEUUID_INX on MODE_SIMPLE_NODE (WORKSPACE_ID, NODE_UUID);
alter table MODE_SIMPLE_NODE add constraint FKE43E2BD346EF783F foreign key (CHILD_NAME_NS_ID) references DNA_NAMESPACES;
alter table MODE_SIMPLE_NODE add constraint FKE43E2BD360F39011 foreign key (PARENT_ID) references MODE_SIMPLE_NODE;
create index QUERYID_INX on MODE_SUBGRAPH_NODES (QUERY_ID, UUID, DEPTH);
alter table ModeShape_LARGEVALUE_USAGES add constraint FK4B54E5DAE58CEC5C foreign key (ID) references MODE_SIMPLE_NODE;
alter table ModeShape_LARGEVALUE_USAGES add constraint FK4B54E5DA1B6FBC1C foreign key (largeValues_SHA1) references MODE_SIMPLE_LARGE_VALUES;
create sequence hibernate_sequence;
